CON

  ' Clock Mode
  '_clkmode = RCFast {  
  _clkmode        = xtal1 + pll16x
  _xinfreq        = 5_000_000 '}
      
  COM_BAUD = 460_800 ' 9_600, 57_600, 115_200, 230_400, 250_000, 460_800
  TEST_LINK_BAUD = 100_000_000 ' will be clamped internally to the min allowable period

  ' NOTE!  You will need to change these if they are already in use.
  dummy_pin1 = 0
  dummy_pin2 = 1

  ' stress test TX buffer...should be < RX buffer size
  BUF_SIZE   = 2000

      
OBJ
  term:         "FFDS1"
  fds_test[2]:  "FFDS1"

VAR
  byte send_buf[BUF_SIZE]

PUB main : i | t, c1, c2, r, ok

  ' serial link back to the PC 
  term.Start( 31, 30, COM_BAUD )

  ' test linkage
  fds_test[0].Start( dummy_pin1, dummy_pin2, TEST_LINK_BAUD )
  fds_test[1].Start( dummy_pin2, dummy_pin1, TEST_LINK_BAUD )

  ' let the user hit the [Enable] button on the Parallax Serial Terminal
  waitcnt( clkfreq * 2 + cnt )

  t := cnt
  repeat

    ' Do a bi-directional test
    ok := true
    ' set up a random buffer
    repeat c1 from 0 to constant( BUF_SIZE - 1 )
      ?r
      send_buf[c1] := r
    ' start with a clean slate
    fds_test[0].rxflush
    fds_test[1].rxflush
    ' send it in one go, both directions!
    fds_test[0].TxBufNoWait( @send_buf, BUF_SIZE )
    fds_test[1].TxBufNoWait( @send_buf, BUF_SIZE )
    ' wait for both cogs to finish transmitting
    fds_test[0].WaitForTX
    fds_test[1].WaitForTX
    ' read char by char
    repeat c1 from 0 to constant( BUF_SIZE - 1 )
      c2 := fds_test[0].rx
      if c2 <> send_buf[c1]
        ok := false
        term.str( string( 13, "RX 0 Failed ", 13 ) )
        term.bin( send_buf[c1], 8 )
        term.tx( " " )
        term.dec( send_buf[c1] )
        term.tx( 13 )
        term.bin( c2, 8 )
      c2 := fds_test[1].rx
      if c2 <> send_buf[c1]
        ok := false
        term.str( string( 13, "RX 1 Failed ", 13 ) )
        term.bin( send_buf[c1], 8 )
        term.tx( " " )
        term.dec( send_buf[c1] )
        term.tx( 13 )
        term.bin( c2, 8 )
    if ok
      term.str( string( 13, "Passed" ) )

    ' test helper functions
    c1 := term.HToI( string( "2A" ) )
    term.tx( 13 )
    term.dec( c1 )
    term.tx( 13 )

    ' if the user sent a char we will echo, along with some useless info
    c1 := term.rxcheck
    term.str( string( 13, "Just testing here: " ) )
    if c1 > 0
      term.tx( c1 )
      term.tx( " " ) 
      term.bin( c1, 8 )
      term.tx( " " )
      term.hex( c1, 2 )
      term.tx( " " )
      term.dec( c1 )
      term.tx( " " )
    term.dec( i++ )

    waitcnt( clkfreq + cnt )
      